/* realloc.c
 * SommerCampus 2006
 * Author: Pablo Yanez Trujillo <yanezp@informatik.uni-freiburg.de>
 * License: GPL-2 */

#include <stdio.h>
#include <stdlib.h>

void print_int_array(int *array, size_t len)
{
	int i;

	if(!len)
		return; /* tue nichts */

	printf("array: ");
	
	for(i = 0; i < len - 1; ++i)
		printf("%d, ", array[i]);
	
	printf("%d", array[i]);

	printf("\n");
}

int main(void)
{
	int i, *p, *tmp, d;

	printf("Gib eine Zahl ein: ");
	scanf("%d", &d);

	if(d <= 0) {
		printf("Die Zahl sollte grer oder gleich 1 sein\n");
		return 1;
	}

	p = malloc(sizeof(int) * d);

	for(i = 0; i < d; ++i)
		p[i] = 10*(i+1);

	print_int_array(p, d);

	printf("Gib eine Zahl ein: ");
	scanf("%d", &d);

	if(d <= 0) {
		printf("Die Zahl sollte grer oder gleich 1 sein\n");
		free(p); /* Speicher freigeben */
		return 1;
	}

	tmp = realloc(p, sizeof(int) * d);

	if(!tmp)
	{
		printf("Du hast keinen freien Speicher mehr\n");
		free(p);
		return 1;
	}

	if(p != tmp)
		p = tmp;

	for(i = 0; i < d; ++i)
		p[i] = 10*(i+2);

	print_int_array(p, d);

	free(p);

	return 0;
}
